﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"
popup_name = "sm_popup_admin_referee_punish"

messages = langlib.Strings(lang_dir + "referee/messages_referee_punish.ini")
messages_common = langlib.Strings(lang_dir + "messages_common.ini")

hurt_sounds = [
	"vo/npc/barney/ba_ohshit03.wav",
	"vo/npc/barney/ba_pain01.wav",
	"vo/npc/barney/ba_pain02.wav",
	"vo/npc/barney/ba_pain03.wav",
	"vo/npc/barney/ba_pain04.wav",
	"vo/npc/barney/ba_pain05.wav",
	"vo/npc/barney/ba_pain06.wav",
	"vo/npc/barney/ba_pain07.wav",
	"vo/npc/barney/ba_pain08.wav",
	"vo/npc/barney/ba_pain09.wav",
	"vo/npc/barney/ba_pain10.wav",
	"vo/npc/male01/pain01.wav",
	"vo/npc/male01/pain02.wav",
	"vo/npc/male01/pain03.wav",
	"vo/npc/male01/pain04.wav",
	"vo/npc/male01/pain05.wav",
	"vo/npc/male01/pain06.wav",
	"vo/npc/male01/pain07.wav",
	"vo/npc/male01/pain08.wav",
	"vo/npc/male01/pain09.wav",
	"vo/npc/male01/ow01.wav"
]

cheer_leaders = []

# ******************** Load ********************
def load():
	create_popup()

# ******************** Events ********************
def es_map_start(event_var):
	delete_keygroup()

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if int(event_var["es_userteam"]) > 1:
			if event_var["es_steamid"] in cheer_leaders:
				es.give(event_var["userid"], "player_weaponstrip")
				es.fire(event_var["userid"], "player_weaponstrip", "strip")

				es.server.queuecmd("playerset color %s 255 255 255 150" % (event_var["userid"]))

				es.setplayerprop(event_var["userid"], "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def player_say(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if int(event_var["es_userteam"]) > 1:
			if event_var["es_steamid"] in cheer_leaders:
				player_sound(event_var["userid"], es.ServerVar("sm_referee_sound_cheer_leader_%s" % (random.randint(1, 3))), 1, 0.5)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")
	text = langlib.Strings(lang_dir + "referee/popup_admin_referee_punish.ini")

	popup = popuplib.create(popup_name)

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")

	values = ["fireworks", "give_dope", "out_breath", "lightning", "cheer_leader", "clear_cheer_leader"]
	for i in range(0, len(values)):
		popup.addline("->%s. %s" % (i + 1, text(values[i])))

	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	for i in range(1, 6):
		popup.select(i, select)

	popup.select(6, clear)
	popup.submenu(7, popup_name)
	popup.submenu(8, popup_name)
	popup.submenu(9, "sm_popup_admin_referee")

# ******************** Popup choice ********************
def select(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	if len(playerlib.getPlayerList("#alive")) > 0:
		myPopup = popuplib.easymenu(name, None, punish)
		myPopup.settitle(messages("select_player"))

		for ply in playerlib.getPlayerList("#alive"):
			myPopup.addoption("%s_%s" % (choice, ply.userid), ply.name)

		myPopup.submenu(10, popup_name)

		popuplib.send(name, userid)
	else:
		es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
		popuplib.send(popup_name, userid)

def clear(userid, choice, popupid):
	delete_keygroup()

	tokens = {}
	tokens["name"] = es.getplayername(userid)
	lang_msg("cleared_cheer_leaders", tokens)

	popuplib.send(popup_name, userid)

# ******************** Easymenu choice ********************
def punish(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	type_split = choice.split("_")
	punish = int(type_split[0])
	target = int(type_split[1])

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	if es.exists("userid", target) == 1:
		target = playerlib.getPlayer(target)
		if target.isdead == 0:
			tokens["name"] = player.name
			tokens["target"] = target.name

			if punish == 1:
				fireworks(target)
				lang_msg("fireworks", tokens)
			elif punish == 2:
				give_dope(target)
				lang_msg("give_dope", tokens)
			elif punish == 3:
				out_breath(target)
				lang_msg("out_breath", tokens)
			elif punish == 4:
				lightning(target)
				lang_msg("lightning", tokens)
			elif punish == 5:
				if target.steamid not in cheer_leaders:
					cheer_leader(target)
					lang_msg("cheer_leader", tokens)
				else:
					es.tell(userid, "#green", messages("already_cheer_leader", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("no_player_found", tokens, player.get("lang")))

	popuplib.send(popup_name, userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def fireworks(choice):
	player_sound(choice, es.ServerVar("sm_referee_sound_fireworks"), 1, 0.5)

	player_shake(choice, 2, 100)

	player_push(choice, 5)
	gamethread.delayed(0.1, player_push, (choice, 20))
	gamethread.delayed(0.2, player_push, (choice, 45))
	gamethread.delayed(0.3, player_push, (choice, 80))
	gamethread.delayed(0.4, player_push, (choice, 125))
	gamethread.delayed(0.5, player_push, (choice, 180))
	gamethread.delayed(0.6, player_push, (choice, 245))
	gamethread.delayed(0.7, player_push, (choice, 320))
	gamethread.delayed(0.8, player_push, (choice, 405))
	gamethread.delayed(0.9, player_push, (choice, 500))
	gamethread.delayed(1, player_push, (choice, 605))
	gamethread.delayed(1.1, player_push, (choice, 720))
	gamethread.delayed(1.2, player_push, (choice, 845))
	gamethread.delayed(1.3, player_push, (choice, 980))
	gamethread.delayed(1.4, player_push, (choice, 1125))
	gamethread.delayed(1.5, player_push, (choice, 1280))
	gamethread.delayed(1.6, player_push, (choice, 1445))
	gamethread.delayed(1.7, player_push, (choice, 1620))
	gamethread.delayed(1.8, player_push, (choice, 1805))
	gamethread.delayed(1.9, player_push, (choice, 2000))

	gamethread.delayed(2.5, player_explosion, (choice))
	gamethread.delayed(2.5, player_sound, (choice, "weapons/hegrenade/explode4.wav", 1, 0.5))
	gamethread.delayed(2.5, player_kill, (choice))

def give_dope(choice):
	player_sound(choice, hurt_sounds[random.randint(0, len(hurt_sounds) - 1)], 1, 0.5)

	gamethread.delayed(1.5, player_sound, (choice, es.ServerVar("sm_referee_sound_give_dope"), 1, 0.5))

	es.setplayerprop(choice, "CBasePlayer.m_iDefaultFOV", 155)

	player_shake(choice, 1, 100)
	gamethread.delayed(1.6, player_shake, (choice, 6.6, 25))

	gamethread.delayed(1.6, player_speed, (choice, 1.01))
	gamethread.delayed(1.7, player_speed, (choice, 1.02))
	gamethread.delayed(1.8, player_speed, (choice, 1.04))
	gamethread.delayed(2, player_speed, (choice, 1.08))
	gamethread.delayed(2.5, player_speed, (choice, 1.16))
	gamethread.delayed(3, player_speed, (choice, 1.32))
	gamethread.delayed(3.5, player_speed, (choice, 1.64))
	gamethread.delayed(4, player_speed, (choice, 2.28))
	gamethread.delayed(5, player_speed, (choice, 4.56))
	gamethread.delayed(7, player_speed, (choice, 9.68))

	es.server.queuecmd("usermsg fade %s 1 500 500 255 255 255 200" % (choice))

	gamethread.delayed(2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(2.2, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(2.4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(2.6, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(2.8, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(3, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(3.2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(3.4, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(3.6, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(3.8, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(4.2, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(4.4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(4.6, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(4.8, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(5, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(5.2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(5.4, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(5.6, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(5.8, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(6, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(6.2, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(6.4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(6.6, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(6.8, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(7, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(7.2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(7.4, player_fade, (choice, 2, 400, 400))

	gamethread.delayed(8.2, es.setplayerprop, (choice, "CBasePlayer.m_iDefaultFOV", 90))
	gamethread.delayed(8.2, player_kill, (choice))

def out_breath(choice):
	player_sound(choice, es.ServerVar("sm_referee_sound_out_breath"), 1, 0.5)

	player_shake(choice, 6, 20)

	es.server.queuecmd("usermsg fade %s 2 3000 2000 0 0 0 255" % (choice))

	gamethread.delayed(0.5, player_speed, (choice, 0.95))
	gamethread.delayed(1, player_speed, (choice, 0.9))
	gamethread.delayed(1.5, player_speed, (choice, 0.85))
	gamethread.delayed(2, player_speed, (choice, 0.8))
	gamethread.delayed(2.5, player_speed, (choice, 0.75))
	gamethread.delayed(3, player_speed, (choice, 0.7))
	gamethread.delayed(3.5, player_speed, (choice, 0.65))
	gamethread.delayed(4, player_speed, (choice, 0.6))
	gamethread.delayed(4.2, player_speed, (choice, 0.5))
	gamethread.delayed(4.4, player_speed, (choice, 0.4))
	gamethread.delayed(4.6, player_speed, (choice, 0.3))
	gamethread.delayed(4.8, player_speed, (choice, 0.2))
	gamethread.delayed(5, player_speed, (choice, 0.175))
	gamethread.delayed(5.2, player_speed, (choice, 0.15))
	gamethread.delayed(5.4, player_speed, (choice, 0.125))
	gamethread.delayed(5.6, player_speed, (choice, 0.1))
	gamethread.delayed(5.8, player_speed, (choice, 0.075))
	gamethread.delayed(6, player_speed, (choice, 0.05))
	gamethread.delayed(6.2, player_speed, (choice, 0.025))

	gamethread.delayed(6.2, player_kill, (choice))

def lightning(choice):
	player_sound(choice, es.ServerVar("sm_referee_sound_lightning"), 1.0, 0.5)

	x,y,z = es.getplayerlocation(choice)
	pos1 = "%s,%s,%s" % (x, y, z)
	z += 2000
	pos2 = "%s,%s,%s" % (x, y, z)

	model = es.precachemodel("sprites/lgtning.vmt")

	es.server.queuecmd("es_effect beam %s %s %s %s 0 30 0.1 5 5 0 0 255 255 255 255 100" % (pos1, pos2, model, model))

	x,y,z = es.getplayerlocation(choice)
	pos1 = "%s,%s,%s" % (x, y, z)
	pos2 = "0,0,0"
	es.server.queuecmd("es_xeffect sparks %s 9999 3 %s" % (pos1, pos2))

	gamethread.delayed(0.1, player_kill, (choice))

def cheer_leader(choice):
	cheer_leaders.append(es.getplayersteamid(choice))

	es.give(choice, "player_weaponstrip")
	es.fire(choice, "player_weaponstrip", "strip")

	es.server.queuecmd("playerset color %s 255 255 255 150" % (choice))

	es.setplayerprop(choice, "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def player_explosion(userid):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		x,y,z = es.getplayerlocation(userid)
		es.server.queuecmd("es_xeffect sparks %s,%s,%s 9999 3 0,0,0" % (x, y, z))

def player_push(userid, push):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "0,0,%s" % (push))

def player_speed(userid, speed):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		player.setSpeed(speed)

def player_sound(userid, sound, volume, range):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		es.emitsound("player", userid, sound, volume, range)

def player_shake(userid, time, magnitude):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		es.server.queuecmd("usermsg shake %s %s %s" % (userid, magnitude, time))

def player_fade(userid, style, time, total):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		es.server.queuecmd("usermsg fade %s %s %s %s %s %s %s %s" % (userid, style, time, total, random.randint(0, 255), random.randint(0, 255), random.randint(0, 255), random.randint(100, 255)))

def player_kill(userid):
	es.server.insertcmd("es_xsexec %s kill" % (userid))

def delete_keygroup():
	global cheer_leaders
	cheer_leaders = []

# ******************** Unload ********************
def unload():
	delete_keygroup()

	popuplib.delete(popup_name)