﻿import es
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

popup = popuplib.create("sm_popup_vote_question")

common = langlib.Strings(lang_dir + "popup_common.ini")
messages = langlib.Strings(lang_dir + "vote/messages_vote.ini")
text = langlib.Strings(lang_dir + "vote/popup_vote.ini")

# ******************** Load ********************
def load():
	create_popup()

	es.load("soccer_mod_2010/vote/time")

# ******************** Create popup ********************
def create_popup():
	menu = popuplib.create("sm_popup_vote")

	menu.addline("SOCCER MOD %s" % (text("title")))
	menu.addline(" ")

	number = 0

	if es.ServerVar("sm_module_match_on") == 1:
		number += 1
		menu.addline("->%s. %s" % (number, text("match_start")))
		menu.select(number, match_start)

		number += 1
		menu.addline("->%s. %s" % (number, text("match_stop")))
		menu.select(number, match_stop)

	if es.ServerVar("sm_module_cap_on") == 1:
		number += 1
		menu.addline("->%s. %s" % (number, text("cap_start")))
		menu.select(number, cap_start)

	if number == 0:
		menu.addline("No votes available.")

	menu.addline(" ")
	menu.addline("->0. %s" % (common("close")))

	number += 1
	for i in range(number, 10):
		menu.submenu(i, "sm_popup_vote")

# ******************** Popup choice ********************
def match_start(userid, choice, popupid):
	if es.ServerVar("sm_vote_spam_protect") == 0:
		if es.exists("keygroup", "sm_keygroup_vote") == 0:
			if es.ServerVar("sm_training_cannon_on") == 0:
				if es.ServerVar("sm_training_goals_disabled") == 0:
					if es.ServerVar("sm_cap_fight_started") == 0:
						if es.ServerVar("sm_match_started") == 0:
							if len(playerlib.getPlayerList("#t")) > 0 and len(playerlib.getPlayerList("#ct")) > 0:
								es.msg("#green", "%s has started a start match vote." % (es.getplayername(userid)))

								es.set("sm_vote_question", "Do you want to start a match?")
								es.set("sm_vote_all", 0)
								es.set("sm_vote_percentage", es.ServerVar("sm_vote_percentage_start_match"))
								es.set("sm_vote_block", "soccer_mod_2010/match/start_match")

								es.doblock("soccer_mod_2010/vote/time/start")
							else:
								es.tell(userid, "#green", "No players available for vote.")
								popuplib.send("sm_popup_vote", userid)
						else:
							es.tell(userid, "#green", "Match already started.")
							popuplib.send("sm_popup_vote", userid)
					else:
						es.tell(userid, "#green", "You can not start this vote during a cap fight.")
						popuplib.send("sm_popup_vote", userid)
				else:
					es.tell(userid, "#green", "You can not start this vote when the goals are disabled.")
					popuplib.send("sm_popup_vote", userid)
			else:
				es.tell(userid, "#green", "You can not start this vote when the ball cannon is on.")
				popuplib.send("sm_popup_vote", userid)
		else:
			es.tell(userid, "#green", "A vote is already active.")
			popuplib.send("sm_popup_vote_question", userid)
	else:
		es.tell(userid, "#green", "You have to wait %s seconds before you can use the vote again." % (es.ServerVar("sm_vote_delay")))
		popuplib.send("sm_popup_vote", userid)

def match_stop(userid, choice, popupid):
	if es.ServerVar("sm_vote_spam_protect") == 0:
		if es.exists("keygroup", "sm_keygroup_vote") == 0:
			if es.ServerVar("sm_match_started") == 1:
				if len(playerlib.getPlayerList("#t")) > 0 and len(playerlib.getPlayerList("#ct")) > 0:
					es.msg("#green", "%s has started a stop match vote." % (es.getplayername(userid)))

					es.set("sm_vote_question", "Do you want to stop the match?")
					es.set("sm_vote_all", 0)
					es.set("sm_vote_percentage", es.ServerVar("sm_vote_percentage_stop_match"))
					es.set("sm_vote_block", "soccer_mod_2010/match/stop_match_vote")

					es.doblock("soccer_mod_2010/vote/time/start")
				else:
					es.tell(userid, "#green", "No players available for vote.")
					popuplib.send("sm_popup_vote", userid)
			else:
				es.tell(userid, "#green", "No match started.")
				popuplib.send("sm_popup_vote", userid)
		else:
			es.tell(userid, "#green", "A vote is already active.")
			popuplib.send("sm_popup_vote_question", userid)
	else:
		es.tell(userid, "#green", "You have to wait %s seconds before you can use the vote again." % (es.ServerVar("sm_vote_delay")))
		popuplib.send("sm_popup_vote", userid)

def cap_start(userid, choice, popupid):
	if es.ServerVar("sm_vote_spam_protect") == 0:
		if es.exists("keygroup", "sm_keygroup_vote") == 0:
			if es.ServerVar("sm_match_started") == 0:
				if es.ServerVar("sm_cap_fight_started") == 0:
					es.msg("#green", "%s has started a start cap match vote." % (es.getplayername(userid)))

					es.set("sm_vote_question", "Do you want to start a cap match?")
					es.set("sm_vote_all", 1)
					es.set("sm_vote_percentage", es.ServerVar("sm_vote_percentage_start_cap"))
					es.set("sm_vote_block", "soccer_mod_2010/cap/spec_all_vote")

					es.doblock("soccer_mod_2010/vote/time/start")
				else:
					es.tell(userid, "#green", "You can not start this vote during a cap fight.")
					popuplib.send("sm_popup_vote", userid)
			else:
				es.tell(userid, "#green", "You can not start this vote during a match.")
				popuplib.send("sm_popup_vote", userid)
		else:
			es.tell(userid, "#green", "A vote is already active.")
			popuplib.send("sm_popup_vote_question", userid)
	else:
		es.tell(userid, "#green", "You have to wait %s seconds before you can use the vote again." % (es.ServerVar("sm_vote_delay")))
		popuplib.send("sm_popup_vote", userid)

# ******************** Commands ********************
def cmd_vote():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.exists("keygroup", "sm_keygroup_vote") == 1:
			if es.exists("key", "sm_keygroup_vote", player.steamid) == 0:
				es.tell(userid, "#green", messages("cant_vote", tokens, player.get("lang")))
			else:
				if int(es.keygetvalue("sm_keygroup_vote", player.steamid, "voted")) == 0:
					popuplib.send("sm_popup_vote_question", userid)
				else:
					es.tell(userid, "#green", messages("already_voted", tokens, player.get("lang")))
		else:
			if es.ServerVar("sm_vote_public_on") == 1:
				popuplib.send("sm_popup_vote", userid)
			else:
				if es.exists("key", "soccer_mod_admins", player.steamid) == 1:
					popuplib.send("sm_popup_vote", userid)
				else:
					es.tell(userid, "#green", messages("public_vote_off", tokens, player.get("lang")))
	else:
		messages_common = langlib.Strings(lang_dir + "messages_common.ini")
		es.tell(userid, "#green", messages_common("not_allowed", tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	es.unload("soccer_mod_2010/vote/time")

	popuplib.delete("sm_popup_vote")